//
//  ViewController.m
//  UICollectionViewText
//
//  Created by sunbk on 16/7/8.
//  Copyright © 2016年 xingyuan. All rights reserved.
//

#import "ViewController.h"
#import "CustomCollectionViewCell.h"
#define SCREEN_HEIGHT [UIScreen mainScreen].bounds.size.height
#define SCREEN_WIDTH  [UIScreen mainScreen].bounds.size.width
@interface ViewController ()<UICollectionViewDelegate,UICollectionViewDataSource,UIScrollViewDelegate>
@property (strong ,nonatomic)   UICollectionView * collectionView;
@property (strong ,nonatomic) UIScrollView * scrollView;
@property (assign,nonatomic) float  oldOffsetX;
@property (strong, nonatomic) UIActivityIndicatorView *activityIndicatorView;
@property (nonatomic,strong) NSMutableArray * oneArray;
@property (nonatomic,strong) NSMutableArray * towArray;
@property (nonatomic,strong) NSMutableArray * threeArray;
@property (nonatomic,strong) NSMutableArray * allArray;
@end

@implementation ViewController
- (UIActivityIndicatorView *)activityIndicatorView{
if (!_activityIndicatorView) {
    _activityIndicatorView = [[UIActivityIndicatorView alloc]initWithFrame:[UIScreen mainScreen].bounds];
    [_activityIndicatorView setActivityIndicatorViewStyle:(UIActivityIndicatorViewStyleWhiteLarge)];
    _activityIndicatorView.color =[UIColor whiteColor];
    _activityIndicatorView.backgroundColor = [[UIColor darkGrayColor] colorWithAlphaComponent:0.5];
    [self.view addSubview:_activityIndicatorView];
}
    return _activityIndicatorView;
}


- (void)viewDidLoad {
    [super viewDidLoad];
    UIView * btnBgView =[[UIView alloc]initWithFrame:CGRectMake(0, 20, SCREEN_WIDTH, 60)];
 
    [self.view addSubview:btnBgView];
    UIButton * btn1 =[[UIButton alloc]initWithFrame:CGRectMake(0, 0, SCREEN_WIDTH/3.0, 58)];
    [btn1 setTitle:@"第一页" forState:UIControlStateNormal];
    [btn1 setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
    [btn1 addTarget:self action:@selector(btnOne) forControlEvents:UIControlEventTouchUpInside];
    [btnBgView addSubview:btn1];
    
    
    UIButton * btn2 =[[UIButton alloc]initWithFrame:CGRectMake( CGRectGetMaxX(btn1.frame),0, SCREEN_WIDTH/3.0, 58)];
    [btn2 setTitle:@"第二页" forState:UIControlStateNormal];
    [btn2 addTarget:self action:@selector(btnTwo) forControlEvents:UIControlEventTouchUpInside];
    [btn2 setTitleColor:[UIColor greenColor] forState:UIControlStateNormal];
    [btnBgView addSubview:btn2];
    
    UIButton * btn3 =[[UIButton alloc]initWithFrame:CGRectMake( CGRectGetMaxX(btn2.frame),0, SCREEN_WIDTH/3.0, 58)];
    [btn3 setTitle:@"第三页" forState:UIControlStateNormal];
    [btn3 setTitleColor:[UIColor orangeColor] forState:UIControlStateNormal];
    [btn3 addTarget:self action:@selector(btnThree) forControlEvents:UIControlEventTouchUpInside];
    [btnBgView addSubview:btn3];
    
   _scrollView =[[ UIScrollView alloc]initWithFrame:CGRectMake(0, 58, SCREEN_WIDTH, 2)];
    UIView *line = [[UIView alloc]initWithFrame:CGRectMake(0, 0, SCREEN_WIDTH/3.0, 2)];
    line.backgroundColor = [UIColor blueColor];
    [_scrollView addSubview:line];
    [btnBgView addSubview:_scrollView];
    UICollectionViewFlowLayout * layout = [[UICollectionViewFlowLayout alloc]init];
    layout.scrollDirection = UICollectionViewScrollDirectionHorizontal;
    
    layout.itemSize = CGSizeMake(SCREEN_WIDTH,SCREEN_HEIGHT-80);
    layout.minimumInteritemSpacing  = 0.0 ;
    layout.minimumLineSpacing = 0.0;
     _collectionView  = [[UICollectionView alloc]initWithFrame:CGRectMake(0, 80, SCREEN_WIDTH, SCREEN_HEIGHT-80) collectionViewLayout:layout];
    _collectionView.backgroundColor = [UIColor whiteColor];
    _collectionView.showsHorizontalScrollIndicator = NO;
    _collectionView.pagingEnabled = YES;
    _collectionView.delegate = self;
    _collectionView.dataSource =self;
    [_collectionView registerNib:[UINib nibWithNibName:@"CustomCollectionViewCell"bundle:nil] forCellWithReuseIdentifier:@"CustomCollectionViewCell"];
    [self.view addSubview:_collectionView];
    
    _oneArray = [NSMutableArray array];
     _towArray = [NSMutableArray array];
     _threeArray = [NSMutableArray array];
     _allArray = [NSMutableArray array];
    for (int i  = 0; i < 5; i ++ ) {
        [_oneArray  addObject:@"孙悟空"];
    }
    for (int i  = 0; i < 10; i ++ ) {
        [_towArray  addObject:@"猪八戒"];
    }
    for (int i  = 0; i < 15; i ++ ) {
        [_threeArray  addObject:@"沙和尚"];
    }
    [_allArray addObject:_oneArray];
    [_allArray addObject:_towArray];
    [_allArray addObject:_threeArray];
    
}
- (void)btnOne
{
    if (_oldOffsetX  == 0) {
        return;
    }
    NSIndexPath * cellpath = [NSIndexPath indexPathForItem:(0) inSection:0];
    CustomCollectionViewCell *cell  =    (CustomCollectionViewCell *) [_collectionView  cellForItemAtIndexPath:cellpath];

    [_collectionView setContentOffset:CGPointMake(0, 0) animated:YES];
    [_scrollView setContentOffset:CGPointMake(0, 0) animated:YES];
    _oldOffsetX = 0;
    [self.activityIndicatorView startAnimating];
    dispatch_async(dispatch_get_global_queue(0, 0), ^{
        //分线程做耗时操作 == 数据请求
          sleep(2);
        dispatch_async(dispatch_get_main_queue(), ^{
            
            //回到主线程刷新UI
            
            cell.dataArray = _allArray[cellpath.row] ;
            [cell.myTableView reloadData];
            [self.activityIndicatorView stopAnimating];
            
            
        });
    });

}

- (void)btnTwo
{
    
    if (_oldOffsetX == SCREEN_WIDTH) {
        return;
    }
    NSIndexPath * cellpath = [NSIndexPath indexPathForItem:(1) inSection:0];
    CustomCollectionViewCell *cell  =    (CustomCollectionViewCell *) [_collectionView  cellForItemAtIndexPath:cellpath];
     [_collectionView setContentOffset:CGPointMake(SCREEN_WIDTH, 0) animated:YES];
   
    [_scrollView setContentOffset:CGPointMake(-SCREEN_WIDTH/3.0, 0) animated:YES];
    _oldOffsetX = SCREEN_WIDTH;
    [self.activityIndicatorView startAnimating];
    dispatch_async(dispatch_get_global_queue(0, 0), ^{
        //分线程做耗时操作 == 数据请求
            sleep(2);
        dispatch_async(dispatch_get_main_queue(), ^{
            
            //回到主线程刷新UI
            
            cell.dataArray = _allArray[cellpath.row] ;
            [cell.myTableView reloadData];
            [self.activityIndicatorView stopAnimating];
            
            
        });
    });

}
- (void)btnThree
{
    if (_oldOffsetX == SCREEN_WIDTH*2) {
        return;
    }
    NSIndexPath * cellpath = [NSIndexPath indexPathForItem:(2) inSection:0];
    CustomCollectionViewCell *cell  =    (CustomCollectionViewCell *) [_collectionView  cellForItemAtIndexPath:cellpath];
     [_collectionView setContentOffset:CGPointMake(SCREEN_WIDTH*2, 0) animated:YES];
     [_scrollView setContentOffset:CGPointMake(-SCREEN_WIDTH*2/3.0, 0) animated:YES];
    _oldOffsetX = SCREEN_WIDTH*2;
    [self.activityIndicatorView startAnimating];
    
    dispatch_async(dispatch_get_global_queue(0, 0), ^{
        //分线程做耗时操作 == 数据请求
          sleep(2);
        dispatch_async(dispatch_get_main_queue(), ^{
            
            //回到主线程刷新UI
            
            cell.dataArray = _allArray[cellpath.row] ;
            [cell.myTableView reloadData];
            [self.activityIndicatorView stopAnimating];
            
            
        });
    });
 
}
- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{

    return 3;

}
- (UICollectionViewCell*)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    CustomCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"CustomCollectionViewCell" forIndexPath:indexPath];
    cell.dataArray = _allArray[indexPath.row];
    [cell.myTableView reloadData];
    return cell;

}
- (void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView
{
    if ([scrollView isEqual:_collectionView]) {
         [_scrollView setContentOffset:CGPointMake((-SCREEN_WIDTH/3.0)*(scrollView.contentOffset.x/SCREEN_WIDTH), 0) animated:YES];
            if (_oldOffsetX !=scrollView.contentOffset.x ) {
                
            [self.activityIndicatorView startAnimating];

         dispatch_async(dispatch_get_global_queue(0, 0), ^{
                //分线程做耗时操作 == 数据请求
             sleep(2); //睡眠线程
            dispatch_async(dispatch_get_main_queue(), ^{
            
                //回到主线程刷新UI
                
                [self.activityIndicatorView stopAnimating];

                });
            });

        }
        _oldOffsetX = scrollView.contentOffset.x;
       
    }
   
}
@end
